<template>
  <div class="edit-product">
    <div v-show="!showEditForm">
      <div class="edit-product-filters">
        <div>
          <input type="text" placeholder="поиск ..." class="main-input" v-model="filters.filterKey">
        </div>
        <div class="form-group m-dropdown" v-click-outside="hideCategories">
          
          <label class="filter-label" @click="showCategories = true;"><span>КАТЕГОРИЯ</span> <span class="fa fa-angle-down"></span></label>

          <ul v-if="showCategories" class="m-dropdown-menu" >
            <li v-for="c in categories" @click.stop="setCategory(c)">{{c}} <span v-if="filters.category.includes(c)" class="checked pull-right"></span></li>
          </ul>
        </div>
      </div>

      <div>
        <table class="table app-table">
          <thead>
            <tr>
              <th>Фото</th>
              <th>Название</th>
              <th>Категория</th>
              <th>Осталось</th>
              <th>Цена</th>
              <th>Действия</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="item in limitedData">
              <td><img :src="getImageUrl(item)" height="100"></td>
              <td>{{item.productName}}</td>
              <td>{{item.productCategory}}</td>
              <td>{{item.itemsLeft}}</td>
              <td>{{item.items[0].price}} грн</td>
              <td>
                <div>
                  <button class="action-button main-button" @click="setEditItem(item)">Изменить</button>
                  <button class="action-button delete-button mt-1" @click="setDeleteItem(item)">Удалить</button>
                </div>
              </td>
            </tr>
          </tbody>
        </table>

        <nav class="navigation pagination" v-if="noPages.length > 1">
          <div class="nav-links">
            <a :class="{disabled: (currentPage === 0)}" @click="previous" class="prev page-numbers">Предыдущая</a>
            <a v-for="(page, ind) in noPages" class="page-numbers" :class="{current: page === currentPage}" @click='(e) => {goToPage(page, e)}'><span class="meta-nav screen-reader-text"></span>{{page + 1}}</a>
            <a :class="{disabled: (currentPage + 1 === noPages.length)}" class="next page-numbers" @click="next">Следущая</a>
          </div>
        </nav>
      </div>
    </div>
    <div v-show="showEditForm">
      <product-form v-if="editItem" :editItem="editItem" @goBack="showEditForm = false; editItem = undefined;" @editItem="updateItem"></product-form>
    </div>

    <modal :header="'Подтвердите Действие'" :isShow="showDeleteModal" v-if="showDeleteModal" @close="showDeleteModal = false">
      <div slot="body">
        <p>Вы уверены, что хотите удалить товар ?</p>
      </div>

      <div slot="footer">
        <button class="ml-2 action-button delete-button pull-right" @click="confirmDelete">УДАЛИТЬ</button>
        
      </div>
    </modal>
  </div>
</template>
<script>
import ProductForm from "./ProductForm.vue";
import Modal from "../../shared/Modal";
export default {
  data() {
    return {
      products: undefined, categories: undefined, editItem: undefined,
      loading: false, showCategories: false, showEditForm: false, showDeleteModal: false,
      currentPage: 0,
      filters: {
        filterKey: '',
        category: []
      }
    }
  },
  methods: {
    getProducts,
    getImageUrl,
    hideCategories,
    setCategory,
    setDeleteItem,
    confirmDelete,
    setEditItem,
    updateItem,
    previous: function (e) { // Previous page click handler
      e.preventDefault()
      if (this.currentPage !== 0) {
        --this.currentPage
      }
    },
    next: function (e) { // Next page click handler
      e.preventDefault()
      if (this.currentPage + 1 !== this.noPages.length) {
        ++this.currentPage
      }
    },
    goToPage: function (page, e) { // Go to a specific page click handler
      e.preventDefault();
      this.currentPage = page;
    },
    firstPage: function(e) {
      e.preventDefault();
      this.currentPage = 0;
    }
  },
  watch: {
    'filters': {
      deep: true,
      handler: function(nVal) {
        this.currentPage = 0;
      } 
    }
  },
  computed: {
    noPages: function () { // No. pages as an array. Used for rendering paginator
      if (!this.filteredData) return [];
      let pages = Math.ceil(this.filteredData.length / 10);
      pages = [...Array(pages).keys()];
      pages = pages.filter(num => {
        return num < this.currentPage + 10 && num > this.currentPage - 10;
      }); 

      return pages;
    },
    limitedData: function () { 
      if (!this.filteredData) return [];
      let limitedData = this.filteredData.slice(
        this.currentPage * 10,
        10 * (this.currentPage + 1)
      );
      return limitedData;
    },
      filteredData: function () { // Data filtered through the local search
        if (!this.products) return [];
        var filterKey = this.filters.filterKey && this.filters.filterKey.toLowerCase();
        var data = this.products;
        if (filterKey) {
          data = data.filter((pr) => pr.productName.toLowerCase().indexOf(filterKey) > -1);
        }

        if (this.filters.category && this.filters.category.length >= 1) {
          data = data.filter(pr => this.filters.category.includes(pr.productCategory));
        }
        
        return data
      }
  },
  components: {
    ProductForm, Modal
  },
  mounted() {
    this.getProducts();
  }
}

function setDeleteItem(item) {
  this.itemToDelete = item._id;
  this.showDeleteModal = true;
}

function confirmDelete() {
  this.products.some((i, ind, arr) => {
    if (i._id === this.itemToDelete) {
      arr.splice(ind, 1);
      return true;
    }
  });
  this.showDeleteModal = false;
  this.$http.delete(`${process.env.VUE_APP_BASE_URL}/products/${this.itemToDelete}`).catch(err => {
    console.log(err);
  })
}

function setEditItem(item) {
  this.editItem = item;
  this.showEditForm = true;
}

function getProducts() {
  this.loading = true;
  this.$http
    .get(`${process.env.VUE_APP_BASE_URL}/products`)
    .then(response => {
      this.loading = false;
      response.data.forEach(item => {
        item.itemsLeft = item.items.reduce((n, i) => {
          n = n + Number(i.quantity);
          return n;
        }, 0);
      })
      this.products = response.data;
      this.categories = response.data.map(pr => pr.productCategory).filter((c, ind, arr) => arr.indexOf(c) === ind);
    })
    .catch(error => {
      console.log(error);
    });
}

function hideCategories() {
  this.showCategories = false;
}

function setCategory(c) {
  if (this.filters.category.includes(c)) {
    this.filters.category.some((c1, ind, arr) => {
      if (c1 === c) {
        arr.splice(ind, 1);
      }
    });
  } else {
    this.filters.category.push(c);
  }
}

function getImageUrl(item) {
  return item.files.find(f => f.main).url;
}

function updateItem(item) {
  item.itemsLeft = item.items.reduce((n, i) => {
    n = n + Number(i.quantity);
    return n;
  }, 0);
  this.products.some((i, ind, arr) => {
    if (i._id === item._id) {
      arr.splice(ind, 1, item);
      return true;
    }
  });
}

</script>
<style lang="scss">
  .edit-product {
    table .action-button {
      margin-top: 0;
      padding: 5px 10px;
    }

    .m-dropdown {
      display: inline-block;
      min-width: 200px;
    }
  }

  
  .edit-product-filters {
    & > div:first-child {
      display: inline-block;
      max-width: 250px;
      padding-right: 20px;
      margin-right: 20px;
      border-right: 1px solid lightgray;
    }
  }
  .pagination {
    text-align: center;
    margin-top: 30px;
    display: inline-block;
    width: 100%;

    .nav-links {
      display: inline-block;

      & > .page-numbers {
        background-color: #fff;
        border-radius: 0;
        border: none;
        border-left: 1px solid #ebebeb;
        border-right: 1px solid #ebebeb;
        color: #464646;
        font-size: 12px;
        font-weight: bold;
        float: left;
        margin: 0;
        padding: 5px 14px;
        text-transform: uppercase;
        text-decoration: none;
        -webkit-transition: all 1s ease 0s;
        -moz-transition: all 1s ease 0s;
        -o-transition: all 1s ease 0s;
        transition: all 1s ease 0s;

        &.current, &:focus, &:hover {
            background-color: #ebebeb;
            border-color: transparent;
            color: #464646;
        }
      }
    }
  }




</style>